/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11 by edhill, Mon Sep 29 16:15:23 2003 UTC revision 1.110 by edhill, Wed Oct 27 18:25:05 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20    }
21    
22    # Search for particular CPP #cmds associated with MPI
23    # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24    test_for_mpi_in_cpp_eeoptions() {
25        cpp_options=$1
26        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38        RETVAL=$?
39        if test "x${RETVAL}" = x0 ; then
40            printf "Error: In $file there is an illegal line: "
41            grep -i "$strng" $file
42            return 1
43        fi
44        return 0
45    }
46    
47    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
48    # the package list.
49    expand_pkg_groups() {
50        new_packages=
51        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
52        if test -r $PKG_GROUPS ; then
53            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
54            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
55            matched=0
56            for i in $PACKAGES ; do
57                line=`grep "^ *$i" ./p2.tmp`
58                RETVAL=$?
59                if test "x$RETVAL" = x0 ; then
60                    matched=1
61                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
62                    echo "    replacing \"$i\" with: $replace"
63                    new_packages="$new_packages $replace"
64                else
65                    new_packages="$new_packages $i"
66                fi
67            done
68            PACKAGES=$new_packages
69            rm -f ./p[1,2].tmp
70            return $matched
71        else
72            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73        fi
74    }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
253            
254      echo "test" > test      echo "test" > test
255      ln -s ./test link      ln -s ./test link
# Line 45  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # look for possible fortran compilers      look_for_makedepend
271      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"  
272        #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
316          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 63  EOF Line 327  EOF
327              p_FC="$p_FC $c"              p_FC="$p_FC $c"
328          fi          fi
329      done      done
330        rm -f ./hello.f ./hello
331      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
332          cat 1>&2 <<EOF          cat 1>&2 <<EOF
333    
# Line 70  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 78  EOF Line 343  EOF
343          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | awk '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 144  get_pdepend_list()  { Line 418  get_pdepend_list()  {
418      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
419      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
420      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
421          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
422          > ./.pd_tmp          > ./.pd_tmp
423      source ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
430  #  Explain usage  #  Explain usage
431  usage()  {  usage()  {
432      echo  cat <<EOF
433      echo "Usage: "$0" [OPTIONS]"  
434      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
435      echo    where [OPTIONS] can be:
436      echo "    -help | --help | -h | --h"  
437      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
438      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
439      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
440      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
443      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
444      echo "    -make NAME | -m NAME"  
445      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
446      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
448      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
449      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
450      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
451      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
452      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
453      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
454      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
455      echo "      -disable=NAME | --disable=NAME"  
456      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
457      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
458      echo "    -noopt NAME | --noopt NAME"            Get the default package list from "NAME".
459      echo "      -noopt=NAME | --noopt=NAME"  
460  #    echo "    -cpp NAME | --cpp NAME"      -make NAME | -m NAME
461  #    echo "      -cpp=NAME | --cpp=NAME"        --make=NAME | -m=NAME
462      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"            Use "NAME" for the MAKE program. The default is "make" but
463      echo "      -fc=NAME | --fc=NAME"            many platforms, "gmake" is the preferred choice.
464      echo "    -[no]ieee | --[no]ieee"  
465      echo "    -[no]mpi | --[no]mpi"      -makefile NAME | -mf NAME
466      echo "    -[no]jam | --[no]jam"        --makefile=NAME | -mf=NAME
467      echo            Call the makefile "NAME".  The default is "Makefile".
468      echo "  and NAME is a string such as:"  
469      echo      -makedepend NAME | -md NAME
470      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"        --makedepend=NAME | -md=NAME
471      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            Use "NAME" for the MAKEDEPEND program.
472      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"  
473      echo      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474      echo "  which, depending upon your shell, may need to be single-quoted"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475      echo "  if it contains spaces, dashes, or other special characters."            Specify the location of the MITgcm ROOTDIR as "NAME".
476              By default, genamke will try to find the location by
477              looking in parent directories (up to the 5th parent).
478    
479        -mods NAME | --mods NAME | -mo NAME | --mo NAME
480          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
481              Here, "NAME" specifies a list of directories that are
482              used for additional source code.  Files found in the
483              "mods list" are given preference over files of the same
484              name found elsewhere.
485    
486        -disable NAME | --disable NAME
487          -disable=NAME | --disable=NAME
488              Here "NAME" specifies a list of packages that we don't
489              want to use.  If this violates package dependencies,
490              genamke will exit with an error message.
491    
492        -enable NAME | --enable NAME
493          -enable=NAME | --enable=NAME
494              Here "NAME" specifies a list of packages that we wish
495              to specifically enable.  If this violates package
496              dependencies, genamke will exit with an error message.
497    
498        -standarddirs NAME | --standarddirs NAME
499          -standarddirs=NAME | --standarddirs=NAME
500              Here, "NAME" specifies a list of directories to be
501              used as the "standard" code.
502    
503        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
504          -fc=NAME | --fc=NAME
505              Use "NAME" as the fortran compiler.  By default, genmake
506              will search for a working compiler by trying a list of
507              "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514        -[no]ieee | --[no]ieee
515              Do or don't use IEEE numerics.  Note that this option
516              *only* works if it is supported by the OPTFILE that
517              is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529      While it is most often a single word, the "NAME" variables specified
530      above can in many cases be a space-delimited string such as:
531    
532        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
533        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
534        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
535    
536      which, depending upon your shell, may need to be single-quoted.
537    
538      For more detailed genmake documentation, please see:
539    
540        http://mitgcm.org/devel_HOWTO/
541    
542    EOF
543    
544      exit 1      exit 1
545  }  }
546    
547  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
548  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
549  #eh3 set CPP        = ( '/lib/cpp -P' )  
550  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551  #eh3 set KPP        = (  )      if test ! "x$FC_NAMEMANGLE" = x ; then
552  #eh3 set FC         = ( 'f77' )          return 0
553  #eh3 set LINK       = $FC      fi
554  #eh3 set MAKEDEPEND = ( 'makedepend' )  
555  #eh3 set INCLUDES   = ( -I. )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556  #eh3 set FFLAGS     = (  )      
557  #eh3 set FOPTIM     = (  )      cat > genmake_test.c <<EOF
558  #eh3 set CFLAGS     = (  )  void tcall( char * string ) { tsub( string ); }
559  #eh3 set KFLAGS1    = (  )  EOF
560  #eh3 set KFLAGS2    = (  )      $MAKE genmake_test.o >> genmake_warnings 2>&1
561  #eh3 set LIBS       = (  )      RETVAL=$?
562  #eh3 set KPPFILES   = (  )      if test "x$RETVAL" != x0 ; then
563  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          FC_NAMEMANGLE=$default_nm
564  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          cat <<EOF>> genmake_errors
565    
566    WARNING: C test compile fails
567    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
568    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
569    EOF
570            return 1
571        fi
572        c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573        RETVAL=$?
574        if test "x$RETVAL" != x0 ; then
575            FC_NAMEMANGLE=$default_nm
576            cat <<EOF>> genmake_warnings
577    
578    WARNING: The "nm" command failed.
579    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
580    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
581    EOF
582            return 1
583        fi
584        cat > genmake_tcomp.f <<EOF
585          subroutine tcall( string )
586          character*(*) string
587          call tsub( string )
588          end
589    EOF
590        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
591        RETVAL=$?
592        if test "x$RETVAL" != x0 ; then
593            FC_NAMEMANGLE=$default_nm
594            cat <<EOF>> genmake_warnings
595    
596    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
597    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
598    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
599    EOF
600            return 1
601        fi
602        f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603        RETVAL=$?
604        if test "x$RETVAL" != x0 ; then
605            FC_NAMEMANGLE=$default_nm
606            cat <<EOF>> genmake_warnings
607    
608    WARNING: The "nm" command failed.
609    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
610    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
611    EOF
612            return 1
613        fi
614    
615        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
616        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
617        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
618        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
619    
620        nmangle="X"
621        if test "x$c_a" != "x$f_a" ; then
622            comm="echo x$f_a | sed -e 's|x$c_a||'"
623            a=`eval $comm`
624            nmangle="$a ## $nmangle"
625        fi
626        if test "x$c_b" != "x$f_b" ; then
627            comm="echo x$f_b | sed -e 's|x$c_b||'"
628            b=`eval $comm`
629            nmangle="$nmangle ## $b"
630        fi
631    
632        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
633    
634        #  cleanup the testing files
635        rm -f genmake_tcomp.* genmake_test.*
636    }
637    
638    
639    check_HAVE_CLOC()  {
640        get_fortran_c_namemangling
641        cat <<EOF > genmake_tc_1.c
642    $FC_NAMEMANGLE
643    #include <stdio.h>
644    #include <stdlib.h>
645    #include <unistd.h>
646    #include <assert.h>
647    #include <sys/time.h>
648    void FC_NAMEMANGLE(cloc) ( double *curtim )
649    {
650     struct timeval tv1;
651     gettimeofday(&tv1 , (void *)NULL );
652     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
653     *curtim = *curtim/1.E6;
654    }
655    EOF
656        make genmake_tc_1.o >> genmake_tc.log 2>&1
657        RET_C=$?
658        cat <<EOF > genmake_tc_2.f
659          program hello
660          Real*8 wtime
661          external cloc
662          call cloc(wtime)
663          print *," HELLO WORLD", wtime
664          end program hello
665    EOF
666        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
667        RET_F=$?
668        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
669        RETVAL=$?
670        if test "x$RETVAL" = x0 ; then
671            HAVE_CLOC=t
672            DEFINES="$DEFINES -DHAVE_CLOC"
673        fi
674        rm -f genmake_tc*
675    }
676    
677    
678    check_HAVE_STAT()  {
679        get_fortran_c_namemangling
680        cat <<EOF > genmake_tc_1.c
681    $FC_NAMEMANGLE
682    #include <stdio.h>
683    #include <stdlib.h>
684    #include <unistd.h>
685    #include <sys/stat.h>
686    #include <sys/types.h>
687    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
688    {
689        char name[512];
690        struct stat astat;
691    
692        name[0] = 'a'; name[1] = '\0';
693        if (! stat(name, &astat))
694            *nbyte = (int)(astat.st_size);
695        else
696            *nbyte = -1;
697    }
698    EOF
699        make genmake_tc_1.o >> genmake_tc.log 2>&1
700        RET_C=$?
701        cat <<EOF > genmake_tc_2.f
702          program hello
703          integer nbyte
704          call tfsize(nbyte)
705          print *," HELLO WORLD", nbyte
706          end program hello
707    EOF
708        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
709        RET_F=$?
710        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
711        RETVAL=$?
712        if test "x$RETVAL" = x0 ; then
713            HAVE_STAT=t
714            DEFINES="$DEFINES -DHAVE_STAT"
715        fi
716        rm -f genmake_tc*
717    }
718    
719    
720    check_netcdf_libs()  {
721        echo "" > genmake_tnc.log
722        cat <<EOF > genmake_tnc.for
723          program fgennc
724    #include "netcdf.inc"
725          integer iret, ncid, xid
726          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
727          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
728          iret = nf_def_dim(ncid, 'X', 11, xid)
729          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
730          iret = nf_close(ncid)
731          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
732          end
733    EOF
734        #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"
735        #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"
736        #echo "$LINK -o genmake_tnc.o $LIBS"
737        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
738            &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
739            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
740        RET_COMPILE=$?
741    
742        #EH3  Remove test program execution for machines that either disallow
743        #EH3  execution or cannot support it (eg. cross-compilers)
744        #EH3
745        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
746        #EH3 RETVAL=$?
747        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
748    
749        if test "x$RET_COMPILE" = x0 ; then
750            HAVE_NETCDF=t
751        else
752            # try again with "-lnetcdf" added to the libs
753            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
754                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
755                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
756            RET_COMPILE=$?
757            if test "x$RET_COMPILE" = x0 ; then
758                LIBS="$LIBS -lnetcdf"
759                HAVE_NETCDF=t
760            else
761                cat genmake_tnc.log >> genmake_warnings
762            fi
763        fi
764        rm -f genmake_tnc*
765    }
766    
767    
768    
769    ###############################################################################
770    #   Sequential part of script starts here
771    ###############################################################################
772    
773  #  Set defaults here  #  Set defaults here
774  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 229  LN= Line 778  LN=
778  S64=  S64=
779  KPP=  KPP=
780  FC=  FC=
781    #CC=gcc
782    CPP=
783  LINK=  LINK=
784  DEFINES="-DWORDLENGTH=4"  DEFINES=
785  PACKAGES=  PACKAGES=
786  ENABLE=  ENABLE=
787  DISABLE=  DISABLE=
788  MAKEFILE=  MAKEFILE=
789  MAKEDEPEND=  #MAKEDEPEND=
790  PDEPEND=  PDEPEND=
791  DUMPSTATE=t  DUMPSTATE=t
792  PDEFAULT=  PDEFAULT=
# Line 246  FOPTIM= Line 797  FOPTIM=
797  CFLAGS=  CFLAGS=
798  KFLAGS1=  KFLAGS1=
799  KFLAGS2=  KFLAGS2=
800    #LDADD=
801  LIBS=  LIBS=
802  KPPFILES=  KPPFILES=
803  NOOPTFILES=  NOOPTFILES=
804  NOOPTFLAGS=  NOOPTFLAGS=
805    MPI=
806    MPIPATH=
807    
808    # DEFINES checked by test compilation
809    HAVE_SYSTEM=
810    HAVE_FDATE=
811    FC_NAMEMANGLE=
812    HAVE_CLOC=
813    HAVE_STAT=
814    HAVE_NETCDF=
815    HAVE_ETIME=
816    
817  MODS=  MODS=
818  TOOLSDIR=  TOOLSDIR=
819  SOURCEDIRS=  SOURCEDIRS=
820  INCLUDEDIRS=  INCLUDEDIRS=
821    STANDARDDIRS="USE_THE_DEFAULT"
822    
823    G2ARGS=
824    BASH=
825  PWD=`pwd`  PWD=`pwd`
826  MAKE=make  MAKE=make
827  THISHOSTNAME=`hostname`  AWK=awk
828    THISHOST=`hostname`
829  THISCWD=`pwd`  THISCWD=`pwd`
830  THISDATE=`date`  THISDATE=`date`
831    THISUSER=`echo $USER`
832    THISVER=
833  MACHINE=`uname -a`  MACHINE=`uname -a`
834  EXECUTABLE=  EXECUTABLE=
835  EXEHOOK=  EXEHOOK=
836  EXEDIR=  EXEDIR=
837    PACKAGES_CONF=
838    IEEE=
839    if test "x$MITGCM_IEEE" != x ; then
840        IEEE=$MITGCM_IEEE
841    fi
842    FS=
843    FS90=
844    
845    AUTODIFF_PKG_USED=f
846    AD_OPTFILE=
847    TAF=
848    AD_TAF_FLAGS=
849    FTL_TAF_FLAGS=
850    SVD_TAF_FLAGS=
851    TAF_EXTRA=
852    TAMC=
853    AD_TAMC_FLAGS=
854    FTL_TAF_FLAGS=
855    SVD_TAMC_FLAGS=
856    TAMC_EXTRA=
857    
858    
859  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
860  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
861  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
862    
863  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
864  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
865  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
866  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
867  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
868    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
869    
870  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
871    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
872    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
873    gm_s12="TAF_EXTRA TAMC_EXTRA"
874    
875    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
876    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
877    
878    cat <<EOF
879    
880    GENMAKE :
881    
882    A program for GENerating MAKEfiles for the MITgcm project.  For a
883    quick list of options, use "genmake -h" or for more detail see:
884    
885      http://mitgcm.org/devel_HOWTO/
886    
887    EOF
888    
 echo  
889  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
890  gm_local="./gm_local"  gm_local="genmake_local"
891  echo -n "  getting local config information:  "  for i in . $MODS ; do
892  if test -e $gm_local ; then      if test -r $i/$gm_local ; then
893            . $i/$gm_local
894            break
895        fi
896    done
897    printf "  getting local config information:  "
898    if test -f $gm_local ; then
899      echo "using $gm_local"      echo "using $gm_local"
900      source $gm_local      . $gm_local
901      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
902      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
903  else  else
904      echo "none found"      echo "none found"
905  fi  fi
906    
907  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
908  #OPTIONS=  #OPTIONS=
909  #n=0  #n=0
910  #for i ; do  #for i ; do
# Line 303  fi Line 915  fi
915  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
916  #done  #done
917  #parse_options  #parse_options
   
918  ac_prev=  ac_prev=
919  for ac_option ; do  for ac_option in "$@" ; do
920    
921        G2ARGS="$G2ARGS \"$ac_option\""
922    
923      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
924      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 328  for ac_option ; do Line 941  for ac_option ; do
941          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
942              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
943                    
944            -adoptfile | --adoptfile | -adof | --adof)
945                ac_prev=AD_OPTFILE ;;
946            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
947                AD_OPTFILE=$ac_optarg ;;
948            
949          -pdepend | --pdepend)          -pdepend | --pdepend)
950              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
951          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 343  for ac_option ; do Line 961  for ac_option ; do
961          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
962              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
963                    
964            -bash | --bash)
965                ac_prev=BASH ;;
966            -bash=* | --bash=*)
967                BASH=$ac_optarg ;;
968            
969            -makedepend | --makedepend | -md | --md)
970                ac_prev=MAKEDEPEND ;;
971            -makedepend=* | --makedepend=* | -md=* | --md=*)
972                MAKEDEPEND=$ac_optarg ;;
973            
974          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
975              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
976          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
977              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
978                    
979          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
980              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
981          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
982              PLATFORM=$ac_optarg ;;              echo
983                usage
984                ;;
985                    
986          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
987              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 373  for ac_option ; do Line 1003  for ac_option ; do
1003          -enable=* | --enable=*)          -enable=* | --enable=*)
1004              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
1005                    
1006          -noopt | --noopt)          -standarddirs | --standarddirs)
1007              ac_prev=NOOPT ;;              ac_prev=STANDARDDIRS ;;
1008          -noopt=* | --noopt=*)          -standarddirs=* | --standarddirs=*)
1009              NOOPT=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
1010            
1011  #           -cpp | --cpp)  #           -cpp | --cpp)
1012  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1013  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1014  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1015                        
1016            -cc | --cc)
1017                ac_prev=CC ;;
1018            -cc=* | --cc=*)
1019                CC=$ac_optarg ;;
1020            
1021          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1022              ac_prev=FC ;;              ac_prev=FC ;;
1023          -fc=* | --fc=*)          -fc=* | --fc=*)
1024              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1025                    
1026            -fs | --fs)
1027                ac_prev=FS ;;
1028            -fs=* | --fs=*)
1029                FS=$ac_optarg ;;
1030            
1031            -fs90 | --fs90)
1032                ac_prev=FS90 ;;
1033            -fs90=* | --fs90=*)
1034                FS90=$ac_optarg ;;
1035            
1036          -ieee | --ieee)          -ieee | --ieee)
1037              IEEE=1 ;;              IEEE=true ;;
1038          -noieee | --noieee)          -noieee | --noieee)
1039              IEEE=0 ;;              IEEE= ;;
1040            
1041          -mpi | --mpi)          -mpi | --mpi)
1042              MPI=1 ;;              MPI=true ;;
1043          -nompi | --nompi)          -mpi=* | --mpi=*)
1044              MPI=0 ;;              MPIPATH=$ac_optarg
1045                        MPI=true ;;
1046          -jam | --jam)          
1047              JAM=1 ;;  #       -jam | --jam)
1048          -nojam | --nojam)  #           JAM=1 ;;
1049              JAM=0 ;;  #       -nojam | --nojam)
1050    #           JAM=0 ;;
1051                    
1052          -ds | --ds)          -ds | --ds)
1053              DUMPSTATE=t ;;              DUMPSTATE=t ;;
1054                    
1055            -taf_extra | --taf_extra)
1056                ac_prev=TAF_EXTRA ;;
1057            -taf_extra=* | --taf_extra=*)
1058                TAF_EXTRA=$ac_optarg ;;
1059    
1060            -tamc_extra | --tamc_extra)
1061                ac_prev=TAMC_EXTRA ;;
1062            -tamc_extra=* | --tamc_extra=*)
1063                TAMC_EXTRA=$ac_optarg ;;
1064    
1065          -*)          -*)
1066              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1067              usage              usage
# Line 420  for ac_option ; do Line 1076  for ac_option ; do
1076            
1077  done  done
1078    
1079    if test -f ./.genmakerc ; then
1080        echo
1081        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1082        echo "  file.  This file format is no longer supported.  Please see:"
1083        echo
1084        echo "    http://mitgcm.org/devel_HOWTO/"
1085        echo
1086        echo "  for directions on how to setup and use the new \"genmake2\" input"
1087        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
1088        echo
1089    fi
1090    
1091    #  Find the MITgcm ${ROOTDIR}
1092  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1093      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1094        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1095          ROOTDIR=".."          ROOTDIR=".."
1096      else      else
1097          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1098              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1099                  ROOTDIR=$d                  ROOTDIR=$d
1100                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1101                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1102                  break                  break
1103              fi              fi
# Line 445  if test ! -d ${ROOTDIR} ; then Line 1115  if test ! -d ${ROOTDIR} ; then
1115      exit 1      exit 1
1116  fi  fi
1117    
1118    #  Find the MITgcm ${THISVER}
1119    if test -f "${ROOTDIR}/doc/tag-index" ; then
1120        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1121    fi
1122    
1123  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1124  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1125      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 458  fi Line 1133  fi
1133  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
1134      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1135          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1136          source "$OPTFILE"          . "$OPTFILE"
1137          RETVAL=$?          RETVAL=$?
1138          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1139              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1140              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1141              exit 1              exit 1
1142          fi          fi
1143          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" != xf ; then
1144              cp -f $OPTFILE "gm_optfile"              cp -f $OPTFILE "genmake_optfile"
1145          fi          fi
1146      else      else
1147          echo "Error: can't read OPTFILE=\"$OPTFILE\""          echo "Error: can't read OPTFILE=\"$OPTFILE\""
# Line 474  if test "x$OPTFILE" != xNONE ; then Line 1149  if test "x$OPTFILE" != xNONE ; then
1149      fi      fi
1150  fi  fi
1151    
1152  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1153  #  and abort!  # check_for_broken_Ff
1154    
1155    echo "  getting AD_OPTFILE information:  "
1156    if test "x${AD_OPTFILE}" = x ; then
1157        if test "x$MITGCM_AD_OF" = x ; then
1158            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1159        else
1160            AD_OPTFILE=$MITGCM_AD_OF
1161        fi
1162    fi
1163    if test "x${AD_OPTFILE}" != xNONE ; then
1164        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1165            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1166            . "$AD_OPTFILE"
1167            RETVAL=$?
1168            if test "x$RETVAL" != x0 ; then
1169                printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1170                echo "--please check that variable syntax is bash-compatible"
1171                exit 1
1172            fi
1173            if test "x$DUMPSTATE" != xf ; then
1174                cp -f $AD_OPTFILE "genmake_ad_optfile"
1175            fi
1176        else
1177            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1178            exit 1
1179        fi
1180    fi
1181    
1182    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1183    #  either set defaults or complain and abort!
1184    if test ! "x$BASH" = x ; then
1185        # add a trailing space so that it works within the Makefile syntax (see below)
1186        BASH="$BASH "
1187    fi
1188  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1189      cat <<EOF 1>&2      cat <<EOF 1>&2
1190    
1191  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
1192    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1193    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
1194    3) the "./gm_local" file    3) the "./genmake_local" file
1195  EOF  EOF
1196      exit 1      exit 1
1197  fi  fi
1198    if test "x$CC" = x ; then
1199        CC=cc
1200    #     cat <<EOF 1>&2
1201    # Error: no C compiler: please specify using one of the following:
1202    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1203    #   2) the "-cc=XXX" command-line option
1204    #   3) the "./genmake_local" file
1205    # EOF
1206    #     exit 1
1207    fi
1208  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1209      LINK=$FC      LINK=$FC
1210  fi  fi
1211    if test "x$MAKE" = x ; then
1212        MAKE="make"
1213    fi
1214  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1215      CPP="cpp"      CPP=cpp
1216  fi  fi
1217  echo "#define A a" | cpp > test_cpp 2>&1  #EH3 === UGLY ===
1218    #  The following is an ugly little hack to check for $CPP in /lib/ and
1219    #  it should eventually be replaced with a more general function that
1220    #  searches a combo of the user's path and a list of "usual suspects"
1221    #  to find the correct location for binaries such as $CPP.
1222    for i in " " "/lib/" ; do
1223        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1224    done
1225    #EH3 === UGLY ===
1226    echo "#define A a" | $CPP > test_cpp 2>&1
1227  RETVAL=$?  RETVAL=$?
1228  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1229      cat <<EOF 1>&2      cat <<EOF 1>&2
# Line 500  if test "x$RETVAL" != x0 ; then Line 1231  if test "x$RETVAL" != x0 ; then
1231  Error: C pre-processor "$CPP" failed the test case: please specify using:  Error: C pre-processor "$CPP" failed the test case: please specify using:
1232    
1233    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1234    2) the "./gm_local" file    2) the "./genmake_local" file
1235      3) with the CPP environment variable
1236    
1237  EOF  EOF
1238      exit 1      exit 1
1239  else  else
1240      rm -f test_cpp      rm -f test_cpp
1241  fi  fi
1242  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1243      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1244        LN="ln -s"
1245    fi
1246    echo "test" > genmake_test_ln
1247    $LN genmake_test_ln genmake_tlink
1248    RETVAL=$?
1249    if test "x$RETVAL" != x0 ; then
1250        cat <<EOF 1>&2
1251    
1252    Error: The command "ln -s" failed -- please specify a working soft-link
1253      command in the optfile.
1254    
1255    EOF
1256        exit 1
1257    fi
1258    rm -f genmake_test_ln genmake_tlink
1259    
1260    #  Check for broken *.F/*.f handling and fix if possible
1261    check_for_broken_Ff
1262    
1263    if test ! "x$MPI" = x ; then
1264          echo "  Turning on MPI cpp macros"
1265          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1266    fi
1267    
1268    printf "\n===  Checking system libraries  ===\n"
1269    printf "  Do we have the system() command using $FC...  "
1270    cat > genmake_tcomp.f <<EOF
1271          program hello
1272          call system('echo hi')
1273          end
1274    EOF
1275    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1276    RETVAL=$?
1277    if test "x$RETVAL" = x0 ; then
1278        HAVE_SYSTEM=t
1279        DEFINES="$DEFINES -DHAVE_SYSTEM"
1280        echo "yes"
1281    else
1282        HAVE_SYSTEM=
1283        echo "no"
1284    fi
1285    rm -f genmake_tcomp*
1286    
1287    printf "  Do we have the fdate() command using $FC...  "
1288    cat > genmake_tcomp.f <<EOF
1289          program hello
1290          CHARACTER(128) string
1291          string = ' '
1292          call fdate( string )
1293          print *, string
1294          end
1295    EOF
1296    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1297    RETVAL=$?
1298    if test "x$RETVAL" = x0 ; then
1299        HAVE_FDATE=t
1300        DEFINES="$DEFINES -DHAVE_FDATE"
1301        echo "yes"
1302    else
1303        HAVE_FDATE=
1304        echo "no"
1305    fi
1306    rm -f genmake_tcomp*
1307    
1308    printf "  Do we have the etime() command using $FC...  "
1309    cat > genmake_tcomp.f <<EOF
1310          program hello
1311          REAL*4 ACTUAL, TARRAY(2)
1312          EXTERNAL ETIME
1313          REAL*4 ETIME
1314          actual = etime( tarray )
1315          print *, tarray
1316          end
1317    EOF
1318    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1319    RETVAL=$?
1320    if test "x$RETVAL" = x0 ; then
1321        HAVE_ETIME=t
1322        DEFINES="$DEFINES -DHAVE_ETIME"
1323        echo "yes"
1324    else
1325        HAVE_ETIME=
1326        echo "no"
1327    fi
1328    rm -f genmake_tcomp*
1329    
1330    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1331    check_HAVE_CLOC
1332    if test "x$HAVE_CLOC" != x ; then
1333        echo "yes"
1334    else
1335        echo "no"
1336    fi
1337    rm -f genmake_t*
1338    
1339    printf "  Can we use stat() through C calls...  "
1340    check_HAVE_STAT
1341    if test "x$HAVE_STAT" != x ; then
1342        echo "yes"
1343    else
1344        echo "no"
1345  fi  fi
1346    rm -f genmake_t*
1347    
1348    printf "  Can we create NetCDF-enabled binaries...  "
1349    check_netcdf_libs
1350    if test "x$HAVE_NETCDF" != x ; then
1351        echo "yes"
1352    else
1353        echo "no"
1354    fi
1355    
1356    
1357  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1358  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1359  for d in $MODS ; do  for d in $MODS ; do
1360      if test ! -d $d ; then      if test ! -d $d ; then
1361          echo          echo
1362          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1363          exit 1          exit 1
1364      else      else
1365          echo -n " $d"          printf " $d"
1366          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1367          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1368      fi      fi
# Line 534  if test "x${PLATFORM}" = x ; then Line 1377  if test "x${PLATFORM}" = x ; then
1377  fi  fi
1378    
1379  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1380      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1381        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1382          EXEDIR=../exe          EXEDIR=../exe
1383      else      else
1384          EXEDIR=.          EXEDIR=.
# Line 549  if test "x${TOOLSDIR}" = x ; then Line 1393  if test "x${TOOLSDIR}" = x ; then
1393      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1394  fi  fi
1395  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1396      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1397      exit 1      exit 1
1398  fi  fi
1399  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1400      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1401        RETVAL=$?
1402        if test "x${RETVAL}" = x0 ; then
1403            S64='$(TOOLSDIR)/set64bitConst.sh'
1404        else
1405            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1406            RETVAL=$?
1407            if test "x${RETVAL}" = x0 ; then
1408                S64='$(TOOLSDIR)/set64bitConst.csh'
1409            else
1410                cat <<EOF
1411    
1412    ERROR: neither of the two default scripts:
1413    
1414        ${TOOLSDIR}/set64bitConst.sh
1415        ${TOOLSDIR}/set64bitConst.csh
1416    
1417      are working so please check paths or specify (with \$S64) a
1418      working version of this script.
1419    
1420    EOF
1421                exit 1
1422            fi
1423        fi
1424  fi  fi
1425    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1426    
1427  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1428    
# Line 563  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1431  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1431  #  they appear as regular source code  #  they appear as regular source code
1432  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1433      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1434      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1435      RETVAL=$?      RETVAL=$?
1436      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1437          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1438      else      else
1439          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1440          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1441          exit 1          exit 1
1442      fi      fi
1443  fi  fi
1444    
1445    #same for exch2
1446    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1447        echo "  Making source files in exch2 from  templates"
1448        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1449        RETVAL=$?
1450        if test "x${RETVAL}" = x0 ; then
1451            rm -f make_exch2.errors
1452        else
1453            echo "Error: problem encountered while building source files in exch2:"
1454            cat make_exch2.errors 1>&2
1455            exit 1
1456        fi
1457    fi
1458    
1459  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1460  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1461      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 593  echo "  getting package dependency info Line 1475  echo "  getting package dependency info
1475  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
1476  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
1477  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
1478      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1479      > ./.pd_tmp      > ./.pd_tmp
1480  RETVAL=$?  RETVAL=$?
1481  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
1482      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1483      exit 1      exit 1
1484  fi  fi
1485  source ./.pd_tmp  . ./.pd_tmp
1486  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1487    
1488  echo  -n "  checking default package list:  "  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1489    #  file should eventually be added so that, for convenience, one can
1490    #  specify groups of packages using names like "ocean" and "atmosphere".
1491    echo "  checking default package list:  "
1492    if test "x${PDEFAULT}" = x ; then
1493        for i in "." $MODS ; do
1494            if test -r $i"/packages.conf" ; then
1495                    PDEFAULT=$i"/packages.conf"
1496                    break
1497            fi
1498        done
1499    fi
1500  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1501      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1502  fi  fi
1503  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1504      echo "default packages file disabled"      echo "    default packages file disabled"
1505  else  else
1506      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1507          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1508      else      else
1509          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1510          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1511          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1512          RETVAL=$?          RETVAL=$?
1513          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1514              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1515              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1516              exit 1              exit 1
1517          fi          fi
1518          for i in $def ; do          for i in $def ; do
1519              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1520          done          done
1521          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1522            RET=1
1523            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1524            echo "    after group expansion packages are:  $PACKAGES"
1525      fi      fi
1526  fi  fi
1527    
1528  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1529    for i in $PACKAGES ; do
1530        echo $i >> ./.tmp_pack
1531    done
1532    for i in `grep  "-" ./.tmp_pack` ; do
1533        j=`echo $i | sed 's/[-]//'`
1534        DISABLE="$DISABLE $j"
1535    done
1536  pack=  pack=
1537  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1538      addit="t"      addit="t"
# Line 645  for p in $PACKAGES ; do Line 1547  for p in $PACKAGES ; do
1547  done  done
1548  PACKAGES="$pack"  PACKAGES="$pack"
1549  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1550  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
1551  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1552    # Test if each explicitly referenced package exists
1553  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1554      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1555        if test ! -d "$ROOTDIR/pkg/$j" ; then
1556          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1557          exit 1          exit 1
1558      fi      fi
1559      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1560  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1561  PACKAGES=  PACKAGES=
1562  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1563      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1564  done  done
1565    rm -f ./.tmp_pack
1566  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1567    
1568    #  Check availability of NetCDF and then either build the MNC template
1569    #  files or delete mnc from the list of available packages.
1570    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1571    RETVAL=$?
1572    if test "x$RETVAL" = x0 ; then
1573        if test "x$HAVE_NETCDF" != xt ; then
1574            cat <<EOF
1575    
1576    *********************************************************************
1577    WARNING: the "mnc" package was enabled but tests failed to compile
1578      NetCDF applications.  Please check that:
1579    
1580      1) NetCDF is correctly installed for this compiler and
1581      2) the LIBS variable (within the "optfile") specifies the correct
1582           NetCDF library to link against.
1583    
1584      Due to this failure, the "mnc" package is now DISABLED.
1585    *********************************************************************
1586    
1587    EOF
1588            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1589            DISABLE="$DISABLE mnc"
1590        else
1591            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1592            RETVAL=$?
1593            if test "x${RETVAL}" = x0 ; then
1594                rm -f make_mnc.errors
1595            else
1596                echo "Error: problem encountered while building source files in pkg/mnc:"
1597                cat make_mnc.errors 1>&2
1598                exit 1
1599            fi
1600        fi
1601    fi
1602    
1603  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1604  ck=  ck=
1605  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 726  while test "x$ck" != xtt ; do Line 1664  while test "x$ck" != xtt ; do
1664              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1665              exit 1              exit 1
1666          fi          fi
1667          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1668            #i=$(( $i + 1 ))
1669      done      done
1670      ck=$ck"t"      ck=$ck"t"
1671  done  done
# Line 736  for i in $PACKAGES ; do Line 1675  for i in $PACKAGES ; do
1675      if test -d $adr ; then      if test -d $adr ; then
1676          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1677          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1678            if test "x$i" = xautodiff ; then
1679                AUTODIFF_PKG_USED=t
1680            fi
1681      else      else
1682          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1683          exit 1          exit 1
1684      fi      fi
1685  done  done
1686    
1687  #  This is compatible with the old genmake.  The "DISABLE_*" flags  # Create a list of #define and #undef to enable/disable packages
1688  #  need to be replaced by the "ALLOW_*" flags set below.  PACKAGES_DOT_H=PACKAGES_CONFIG.h
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 echo "  Searching for CPP_OPTIONS.h (macros and flags for configuring the model):"  
 CPP_OPTIONS=  
 spaths=". $SOURCEDIRS"  
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 C  Packages disabled by genmake:  
 EOF  
1689  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1690  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1691  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1692  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1693  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1694  all_pack=  all_pack=
1695    DISABLED_PACKAGES=
1696  for n in $names ; do  for n in $names ; do
1697      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1698          has_pack="f"          has_pack="f"
# Line 813  for n in $names ; do Line 1703  for n in $names ; do
1703              fi              fi
1704          done          done
1705          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1706              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1707              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1708          fi          fi
1709      fi      fi
1710  done  done
1711  cat <<EOF >>CPP_OPTIONS.h.tmp  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1712  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1713      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1714      echo "#define $def" >> CPP_OPTIONS.h.tmp      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1715    #eh3 DEFINES="$DEFINES -D$def"
1716    
1717  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1718      case $i in      case $i in
1719          aim_v23)          aim_v23)
1720              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1721                echo "Warning: ALLOW_AIM is set to enable aim_v23."
1722              ;;              ;;
1723      esac      esac
1724  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1725    
1726  done  done
 mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  
1727    
1728  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1729  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1730  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1731  for d in $STANDARDDIRS ; do      STANDARDDIRS="eesupp model"
1732      adr="$ROOTDIR/$d/src"  fi
1733      if test ! -d $adr ; then  if test "x$STANDARDDIRS" != x ; then
1734          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""      for d in $STANDARDDIRS ; do
1735          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/src"
1736          exit 1          if test ! -d $adr ; then
1737      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1738          SOURCEDIRS="$SOURCEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1739      fi              exit 1
1740      adr="$ROOTDIR/$d/inc"          else
1741      if test ! -d $adr ; then              SOURCEDIRS="$SOURCEDIRS $adr"
1742          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          fi
1743          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/inc"
1744          exit 1          if test ! -d $adr ; then
1745      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1746          INCLUDEDIRS="$INCLUDEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1747                exit 1
1748            else
1749                INCLUDEDIRS="$INCLUDEDIRS $adr"
1750            fi
1751        done
1752    fi
1753    
1754    echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1755    echo "    of \"#define \"-type statements that are no longer allowed:"
1756    CPP_OPTIONS=
1757    CPP_EEOPTIONS=
1758    spaths=". $INCLUDEDIRS"
1759    names=`ls -1 "$ROOTDIR/pkg"`
1760    for i in $spaths ; do
1761        try="$i/CPP_OPTIONS.h"
1762        if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
1763            echo "    found CPP_OPTIONS=\"$try\""
1764            CPP_OPTIONS="$try"
1765            # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1766            for n in $names ; do
1767                test_for_package_in_cpp_options $CPP_OPTIONS $n
1768            done
1769        fi
1770        try="$i/CPP_EEOPTIONS.h"
1771        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1772            echo "    found CPP_EEOPTIONS=\"$try\""
1773            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1774    #**** not yet enabled ****
1775    #        test_for_mpi_in_cpp_eeoptions $try
1776    #**** not yet enabled ****
1777            CPP_EEOPTIONS="$try"
1778      fi      fi
1779  done  done
1780    if test "x$CPP_OPTIONS" = x ; then
1781        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1782        exit 1
1783    fi
1784    
1785    #  Here, we build the list of files to be "run through" the adjoint
1786    #  compiler.
1787    if test -f ./ad_files ; then
1788        rm -f ./ad_files
1789    fi
1790    echo "  Creating the list of files for the adjoint compiler."
1791    for i in $SOURCEDIRS ; do
1792        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1793        for j in $list_files ; do
1794            cat $i/$j >> ad_files
1795        done
1796    done
1797    
1798    
1799  echo  echo
1800  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1801  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1802  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1803      if test -d $i ; then      if test ! -d $i ; then
         INCLUDES="$INCLUDES -I$i"  
     else  
1804          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1805      fi      fi
1806  done  done
# Line 894  rm -rf .links.tmp Line 1810  rm -rf .links.tmp
1810  mkdir .links.tmp  mkdir .links.tmp
1811  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1812  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1813  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1814  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1815  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1816  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1817    printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1818  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1819  for d in $alldirs ; do  for d in $alldirs ; do
1820      deplist=      deplist=
1821      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1822      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1823      for sf in $sfiles ; do      for sf in $sfiles ; do
1824          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1825              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1826                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  case $d/$sf in
1827                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1828                  deplist="$deplist $sf"                          ;;
1829                      ./AD_CONFIG.h)
1830                            ;;
1831                      ./FC_NAMEMANGLE.h)
1832                            ;;
1833                      ./BUILD_INFO.h)
1834                            ;;
1835                      *)
1836                            touch .links.tmp/$sf
1837                            deplist="$deplist $sf"
1838                            ;;
1839                    esac
1840                    extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1841                  case $extn in                  case $extn in
1842                      F)                      F)
1843                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1844                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1845                          ;;                          ;;
1846                      F90)                      F90)
1847                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1848                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1849                          ;;                          ;;
1850                      c)                      c)
1851                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1852                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1853                          ;;                          ;;
1854                      h)                      h)
1855                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1856                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1857                            ;;
1858                        flow)
1859                            echo    " \\"  >> ad_flow_files.inc
1860                            printf " $sf" >> ad_flow_files.inc
1861                          ;;                          ;;
1862                  esac                  esac
1863              fi              fi
# Line 942  echo "" >> srclist.inc Line 1875  echo "" >> srclist.inc
1875  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1876  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1877  echo "" >> hlist.inc  echo "" >> hlist.inc
1878    echo "" >> ad_flow_files.inc
1879    
1880  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1881      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1882  fi  fi
1883  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 952  echo "#    $MACHINE" >> $MAKEFILE Line 1886  echo "#    $MACHINE" >> $MAKEFILE
1886  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1887  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1888  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1889  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1890  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1891  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1892    
1893    EXE_AD=$EXECUTABLE"_ad"
1894    EXE_FTL=$EXECUTABLE"_ftl"
1895    EXE_SVD=$EXECUTABLE"_svd"
1896    
1897  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1898    #
1899    # OPTFILE="$OPTFILE"
1900  #  #
1901  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1902  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 983  EXEDIR      = ${EXEDIR} Line 1924  EXEDIR      = ${EXEDIR}
1924  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1925  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1926    
1927    #eh3  new defines for the adjoint work
1928    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1929    EXE_AD      = ${EXE_AD}
1930    EXE_FTL     = ${EXE_FTL}
1931    EXE_SVD     = ${EXE_SVD}
1932    
1933    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1934    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1935    
1936    # These files are created by Makefile
1937    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1938    
1939  EOF  EOF
1940    
1941  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1000  KPP = ${KPP} Line 1953  KPP = ${KPP}
1953  FC = ${FC}  FC = ${FC}
1954  # Fortran compiler  # Fortran compiler
1955  F90C = ${F90C}  F90C = ${F90C}
1956    # C compiler
1957    CC = ${CC}
1958  # Link editor  # Link editor
1959  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1960    
1961  # Defines for CPP  # Defines for CPP
1962  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1022  CFLAGS = ${CFLAGS} Line 1977  CFLAGS = ${CFLAGS}
1977  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
1978  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
1979  # Flags and libraries needed for linking  # Flags and libraries needed for linking
1980  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
1981  # Name of the Mekfile  # Name of the Mekfile
1982  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
1983    
1984  EOF  EOF
1985    
1986  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1987  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1988  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1989  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1990  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1991  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo >> $MAKEFILE
1992    echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1993    echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1994  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1995    echo >> $MAKEFILE
1996    echo '.SUFFIXES:' >> $MAKEFILE
1997    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1998  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1999    rm -f ad_flow_files.inc
2000    
2001  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2002    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2003  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2004  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
2005            @echo Creating \$@ ...
2006          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2007  depend:  depend:
2008          @make links          @make links
2009          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2010          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2011            -rm -f makedepend.out
2012    
2013  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2014    
2015  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
2016    
# Line 1060  output.txt: \$(EXECUTABLE) Line 2019  output.txt: \$(EXECUTABLE)
2019          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2020    
2021  clean:  clean:
2022          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2023  Clean:  Clean:
2024          @make clean          @make clean
2025          @make cleanlinks          @make cleanlinks
2026          -rm -f Makefile.bak          -rm -f \$(SPECIAL_FILES)
2027            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2028  CLEAN:  CLEAN:
2029          @make Clean          @make Clean
2030          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2031          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2032          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2033          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt STD*
2034    
2035    #eh3 Makefile: makefile
2036  makefile:  makefile:
2037          ${0} $@          $THIS_SCRIPT $G2ARGS
2038  cleanlinks:  cleanlinks:
2039          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2040    
2041  # The normal chain of rules is (  .F - .f - .o  )  # Special targets (SPECIAL_FILES) which are create by make
2042  .F.f:  ${PACKAGES_DOT_H}:
2043            @echo Creating \$@ ...
2044            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2045    AD_CONFIG.h:
2046            @echo Creating \$@ ...
2047            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2048    FC_NAMEMANGLE.h:
2049            @echo Creating \$@ ...
2050            echo "$FC_NAMEMANGLE" > \$@
2051    
2052    BUILD_INFO.h:
2053            @echo Creating \$@ ...
2054    EOF
2055    
2056    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2057    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2058    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2059    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2060    
2061    cat >>$MAKEFILE <<EOF
2062    
2063    # The normal chain of rules is (  .F - .$FS - .o  )
2064    
2065    ## This nullifies any default implicit rules concerning these two file types:
2066    ## %.o : %.F
2067    
2068    .F.$FS:
2069          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2070  .f.o:  .$FS.o:
2071          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2072  .F90.f90:  .F90.$FS90:
2073          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2074  .f90.o:  .$FS90.o:
2075          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2076  .c.o:  .c.o:
2077          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2078    
2079  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2080  .F.p:  .F.p:
2081          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2082  .p.f:  .p.$FS:
2083          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2084    
2085    #=========================================
2086    #===  Automatic Differentiation Rules  ===
2087    
2088    TAMC           = ${TAMC}
2089    TAF            = ${TAF}
2090    
2091    TAF_EXTRA      = ${TAF_EXTRA}
2092    TAMC_EXTRA     = ${TAMC_EXTRA}
2093    
2094    EOF
2095    
2096    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2097    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2098    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2099    for i in $ad_vars ; do
2100        name=$i
2101        t1="t2=\$"`echo $i`
2102        eval $t1
2103        printf "%-20s = " $name >> $MAKEFILE
2104        echo $t2 >> $MAKEFILE
2105    done
2106    
2107    echo "  Add the source list for AD code generation"
2108    echo >> $MAKEFILE
2109    printf "AD_FILES = " >> $MAKEFILE
2110    AD_FILES=`cat ad_files`
2111    for i in $AD_FILES ; do
2112        echo    " \\" >> $MAKEFILE
2113        printf " $i" >> $MAKEFILE
2114    done
2115    echo >> $MAKEFILE
2116    rm -f ad_files
2117    
2118    cat >>$MAKEFILE <<EOF
2119    
2120    # ... AD ...
2121    adall: ad_taf
2122    adtaf: ad_taf_output.f
2123    adtamc: ad_tamc_output.f
2124    
2125    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2126            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2127            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2128            -rm -f ad_config.template
2129            @make \$(F77FILES)
2130            @make \$(AD_FLOW_FILES)
2131            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
2132    
2133    ad_taf_output.f: ad_input_code.f
2134            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2135            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2136    
2137    adtafonly:
2138            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2139            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2140    
2141    ad_taf: ad_taf_output.o \$(OBJFILES)
2142            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2143    
2144    ad_tamc_output.f: ad_input_code.f
2145            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
2146            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
2147    
2148    ad_tamc: ad_tamc_output.o \$(OBJFILES)
2149            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2150    
2151    adonlyfwd:
2152            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2153    
2154    adtrick:
2155            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2156    
2157    # ... FTL ...
2158    ftlall: ftl_taf
2159    ftltaf: ftl_taf_output.f
2160    ftltamc: ftl_tamc_output.f
2161    
2162    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2163            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2164            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2165            -rm -f ftl_config.template
2166            @make \$(F77FILES)
2167            @make \$(AD_FLOW_FILES)
2168            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
2169    
2170    ftl_taf_output.f: ftl_input_code.f
2171            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2172            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2173    
2174    ftltafonly:
2175            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2176            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2177    
2178    ftl_taf: ftl_taf_output.o \$(OBJFILES)
2179            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2180    
2181    ftl_tamc_output.f: ftl_input_code.f
2182            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
2183            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
2184    
2185    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2186            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2187    
2188    
2189    # ... SVD ...
2190    svdtaf: ad_taf_output.f ftl_taf_output.f
2191            @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2192            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2193    svdall: svd_touch svd_taf
2194    
2195    svd_taf: \$(OBJFILES)
2196            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2197    
2198            @echo "--->>> Only COMPILE svd code! <<<---"
2199            @echo "--->>> Assumes you previously <<<---"
2200            @echo "--->>> did make svdtaf        <<<---"
2201    
2202    svd_touch:
2203            @echo "--->>> Only COMPILE svd code! <<<---"
2204            @echo "--->>> Assumes you previously <<<---"
2205            @echo "--->>> did make svdtaf        <<<---"
2206            touch ad_taf_output.f ftl_taf_output.f
2207            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f
2208            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f
2209            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2210            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2211            -rm -f ftl_config.template
2212    
2213    #=========================================
2214    
2215  EOF  EOF
2216    
2217  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1108  for i in $KPPFILES ; do Line 2225  for i in $KPPFILES ; do
2225      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2226          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2227      fi      fi
2228      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2229  done  done
2230    
2231  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1118  for i in $NOOPTFILES ; do Line 2235  for i in $NOOPTFILES ; do
2235      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2236          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2237      fi      fi
2238      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2239      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2240  done  done
2241    
# Line 1131  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2248  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2248    
2249  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2250    
2251    # Create special header files
2252    $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2253    if test ! -f $PACKAGES_DOT_H ; then
2254        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2255    else
2256        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2257        RETVAL=$?
2258        if test "x$RETVAL" = x0 ; then
2259            rm -f $PACKAGES_DOT_H".tmp"
2260        else
2261            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2262            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2263        fi
2264    fi
2265    if test ! -f AD_CONFIG.h ; then
2266        $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2267    fi
2268    
2269    
2270  #  Write the "state" for future records  #  Write the "state" for future records
2271  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2272      echo -n "" > gm_state      printf "" > genmake_state
2273      for i in $gm_state ; do      for i in $gm_state ; do
2274          t1="t2=\$$i"          t1="t2=\$$i"
2275          eval $t1          eval $t1
2276          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
2277      done      done
2278  fi  fi

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.110

  ViewVC Help
Powered by ViewVC 1.1.22